#!/system/bin/sh

echo

# check ric
RICTYPE=0

if [ -e /sys/kernel/security/sony_ric ]; then
	/data/local/tmp/copymodulecrc /system/lib/modules/scsi_wait_scan.ko /data/local/tmp/ric_disabler_mod.ko
	insmod /data/local/tmp/ric_disabler_mod.ko
	RICTYPE=3
elif [ -e /sbin/ric ]; then
	/data/local/tmp/busybox pkill /sbin/ric
	mount -o remount,rw /
	rm /sbin/ric
	mount -o remount,ro /
	/data/local/tmp/busybox pkill /sbin/ric
	RICTYPE=2
elif [ -e /system/bin/ric ]; then
	/system/bin/stop ric
	/data/local/tmp/busybox pkill /system/bin/ric
	mount -o remount,rw /system
	rm /system/bin/ric
	/data/local/tmp/busybox pkill /system/bin/ric
	/data/local/tmp/busybox cp /data/local/tmp/saferic /system/bin/ric
	chown root.root /system/bin/ric
	chmod 0755 /system/bin/ric
	mount -o remount,ro /system
	RICTYPE=1
fi

echo "rictype=$RICTYPE"

# mount rw
mount -o remount,rw /system

# delete old su
if [ -e /system/bin/su ]; then
	rm /system/bin/su
fi
if [ -e /system/xbin/su ]; then
	rm /system/xbin/su
fi
if [ -e /system/bin/.ext/.su ]; then
	rm /system/bin/.ext/.su
fi
if [ -e /system/bin/install-recovery.sh ]; then
	rm /system/bin/install-recovery.sh
fi
if [ -e /system/etc/install-recovery.sh ]; then
	rm /system/etc/install-recovery.sh
fi
if [ -e /system/xbin/daemonsu ]; then
	rm /system/xbin/daemonsu
fi
if [ -e /system/xbin/sugote ]; then
	rm /system/xbin/sugote
fi
if [ -e /system/xbin/sugote-mksh ]; then
	rm /system/xbin/sugote-mksh
fi
if [ -e /system/app/Superuser.apk ]; then
	rm /system/app/Superuser.apk
fi
if [ -e /system/app/SuperSU.apk ]; then
	rm /system/app/SuperSU.apk
fi
if [ -e /system/app/SuperSU/SuperSU.apk ]; then
	rm /system/app/SuperSU/SuperSU.apk
fi
if [ -e /system/etc/init.d/99SuperSUDaemon ]; then
	rm /system/etc/init.d/99SuperSUDaemon
fi
if [ -e /system/etc/.installed_su_daemon ]; then
	rm /system/etc/.installed_su_daemon
fi

# check API version
API=$(getprop ro.build.version.sdk)

# copy files
dd if=/data/local/tmp/busybox of=/system/xbin/busybox
chown root.shell /system/xbin/busybox
chmod 0755 /system/xbin/busybox
/system/xbin/busybox --install -s /system/xbin

/system/bin/mkdir /system/bin/.ext
chown root.root /system/bin/.ext
chmod 0777 /system/bin/.ext
dd if=/data/local/tmp/su of=/system/bin/.ext/.su
chown root.root /system/bin/.ext/.su
chmod 0755 /system/bin/.ext/.su
dd if=/data/local/tmp/su of=/system/xbin/su
chown root.root /system/xbin/su
chmod 0755 /system/xbin/su
dd if=/data/local/tmp/su of=/system/xbin/daemonsu
chown root.root /system/xbin/daemonsu
chmod 0755 /system/xbin/daemonsu
ln -s /system/xbin/su /system/bin/su
dd if=/data/local/tmp/su of=/system/xbin/sugote
chown root.root /system/xbin/sugote
chmod 0755 /system/xbin/sugote
/system/xbin/cp /system/bin/sh /system/xbin/sugote-mksh
chown root.root /system/xbin/sugote-mksh
chmod 0755 /system/xbin/sugote-mksh

dd if=/data/local/tmp/supolicy of=/system/xbin/supolicy
chown root.root /system/xbin/supolicy
chmod 0755 /system/xbin/supolicy
dd if=/data/local/tmp/libsupol.so of=/system/lib/libsupol.so
chown root.root /system/lib/libsupol.so
chmod 0644 /system/lib/libsupol.so

if [ $API -ge 20 ]; then
	/system/bin/mkdir /system/app/SuperSU
	chown root.root /system/app/SuperSU
	chmod 0755 /system/app/SuperSU
	dd if=/data/local/tmp/Superuser.apk of=/system/app/SuperSU/SuperSU.apk
	chown root.root /system/app/SuperSU/SuperSU.apk
	chmod 0644 /system/app/SuperSU/SuperSU.apk
else
	dd if=/data/local/tmp/Superuser.apk of=/system/app/SuperSU.apk
	chown root.root /system/app/SuperSU.apk
	chmod 0644 /system/app/SuperSU.apk
fi

dd if=/data/local/tmp/install-recovery.sh of=/system/etc/install-recovery.sh
chown root.root /system/etc/install-recovery.sh
chmod 0755 /system/etc/install-recovery.sh
ln -s /system/etc/install-recovery.sh /system/bin/install-recovery.sh

if [ $API -ge 21 ]; then
	if [ ! -e /system/bin/app_process_original ]; then
		/system/xbin/mv /system/bin/app_process /system/bin/app_process_original
		ln -s /system/xbin/daemonsu /system/bin/app_process
	fi
	if [ ! -e /system/bin/app_process32_original ]; then
		/system/xbin/mv /system/bin/app_process32 /system/bin/app_process32_original
		ln -s /system/xbin/daemonsu /system/bin/app_process32
		/system/xbin/cp /system/bin/app_process32_original /system/bin/app_process_init
		chown root.shell /system/bin/app_process_init
		chmod 0755 /system/bin/app_process_init
	fi
fi

# make init.d
if [ ! -e /system/etc/init.d ]; then
	/system/bin/mkdir /system/etc/init.d
fi
chown root.root /system/etc/init.d
chmod 0755 /system/etc/init.d
if [ -e /system/etc/init.qcom.post_boot.sh ]; then
	if grep "/system/xbin/busybox run-parts /system/etc/init.d" /system/etc/init.qcom.post_boot.sh > /dev/null; then
		:
	else
		echo "/system/xbin/busybox run-parts /system/etc/init.d" >> /system/etc/init.qcom.post_boot.sh
	fi
elif [ -e /system/etc/hw_config.sh ]; then
	if grep "/system/xbin/busybox run-parts /system/etc/init.d" /system/etc/hw_config.sh > /dev/null; then
		:
	else
		echo "/system/xbin/busybox run-parts /system/etc/init.d" >> /system/etc/hw_config.sh
	fi
fi

# make SuperSUDaemon
dd if=/data/local/tmp/99SuperSUDaemon of=/system/etc/init.d/99SuperSUDaemon
chown root.root /system/etc/init.d/99SuperSUDaemon
chmod 0755 /system/etc/init.d/99SuperSUDaemon

# mount ro
mount -o remount,ro /system
